//
//  MainWireframe.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/17/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import UIKit

final class MainWireframe: BaseWireframe {

    // MARK: - Private properties -

    private let storyboard = UIStoryboard(name: "Main", bundle: nil)

    // MARK: - Module setup -

    init() {
        let moduleViewController = storyboard.instantiateViewController(ofType: MainViewController.self)
        super.init(viewController: moduleViewController)

        let interactor = MainInteractor()
        let presenter = MainPresenter(view: moduleViewController, interactor: interactor, wireframe: self)
        moduleViewController.presenter = presenter
    }

}

// MARK: - Extensions -

extension MainWireframe: MainWireframeInterface {
    func addTabBarViewControllers() {
        
        let homeWireFrame = HomeWireframe()
        let transactionsWireframe = TransactionsWireframe()
        let productListWireframe = ProductListWireframe()
        let membershipListWireframe = MembershipListWireframe()
        
        let homeTabBarItem = UITabBarItem(
            title: "Trang chủ",
            image: nil,
            tag: 1
        )
        homeWireFrame.viewController.tabBarItem = homeTabBarItem
        
        
        transactionsWireframe.viewController.tabBarItem = UITabBarItem(
            title: "Giao dịch",
            image: nil,
            tag: 4
        )
        
        let productListTabTabBarItem = UITabBarItem(
            title: "Sản phẩm",
            image: nil,
            tag: 5
        )
        let productListViewController = SSMNavigationController(rootViewController: productListWireframe.viewController)
        productListViewController.tabBarItem = productListTabTabBarItem
        
        let membershipListTabTabBarItem = UITabBarItem(
            title: "Thành viên",
            image: nil,
            tag: 6
        )
        let membershipListListViewController = SSMNavigationController(rootViewController: membershipListWireframe.viewController)
        membershipListListViewController.tabBarItem = membershipListTabTabBarItem
        
        let viewControllers  = [
            homeWireFrame.viewController,
            membershipListListViewController,
            transactionsWireframe.viewController,
            productListViewController
        ]
        
        guard let mainViewControler = viewController as? MainViewInterface else { return }
        mainViewControler.addTabBarViewControllers(viewControllers)
    }
    
    enum UIConfig {
        static let normalTabbarIconSize: CGSize = CGSize(width: 20, height: 20)
        static let mainTabbarIconSize: CGSize = CGSize(width: 32, height: 32)
    }
}
